﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {

  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public abstract class Expression {
    protected int id;
    protected string stringRepresentation;

    public string StringRepresentation
    {
      get { return this.stringRepresentation ?? (this.stringRepresentation = this.InitStringRepresentation()); }
    }

    public int Id
    {
      get
      {
        if (this.id == default(int))
          this.id = this.InitId();

        return this.id;
      }
    }

    public abstract void Eval(IPushGpInterpreter interpreter);

    protected abstract int InitId();

    protected abstract string InitStringRepresentation();

    public override bool Equals(object obj) {
      return (obj != null) && ((this.GetHashCode() == obj.GetHashCode()) || (this.GetType() == obj.GetType()));
    }

    public override int GetHashCode() {
      return this.Id;
    }
  }
}